
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>线程基础：JDK1.5+（8）——线程新特性（上） / 憋错料</title>

    <meta name="description" content="线程基础：JDK1.5+（8）——线程新特性（上） 1.概要 如果您阅读JAVA的源代码,出现最多的代码作者包括:Doug Lea.Mark Reinhold.Josh Bloch.Arthur van Hoff.Neal Gafter.Pavani Diwanji等等.其中java.util.concurrent包中出现的基本都是Doug Lea的名字.Doug Lea,是对Java影响力最大的个人,直接贡献的设计包括java的Collections和util.concurrent. JDK1.5中一个重要特性就是util.concurrent">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">线程基础：JDK1.5+（8）——线程新特性（上）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>1、概要</h1>
<p>如果您阅读JAVA的源代码，出现最多的代码作者包括：Doug Lea、Mark Reinhold、Josh Bloch、Arthur van Hoff、Neal Gafter、Pavani Diwanji等等。其中java.util.concurrent包中出现的基本都是Doug Lea的名字。Doug Lea，是对Java影响力最大的个人，直接贡献的设计包括java的Collections和util.concurrent。</p>
<p>JDK1.5中一个重要特性就是util.concurrent包和其子包（当让JDK1.5中的特性还包括了很多，例如泛型、解包/封包等，但这些不属于我们这个专题讨论的范围）。在这个系列的专题中，我们已经对util.concurrent包中的一些主要功能做了介绍，例如：BlockingQueue、ThreadPoolExecutor、Executors等。这篇文章中，我们对这个包中其他中要的线程特性进行介绍。</p>
<h1>2、带返回值的Callable</h1>
<p>在之前的文章中，我们提到JAVA线程相关的Runnable接口中的run()方法没有提供返回值，如下：</p>
<pre><code>......
public void run() {
    ......
}
......</code></pre>
<p>如果您需要在线程A执行完成，得到返回值后，再继续执行某个业务。那么推荐您使用JDK1.5中提供的带有“执行返回值”的线程定义接口：Callable。</p>
<p>如果您还需要为多个线程的执行调度加入更复杂的控制逻辑，那么您需要我们之前讨论过的同步机制和JDK1.5中java.util.concurrent.locks包中的工具配合使用，才能达到效果。</p>
<p>JDK1.5的java.util.concurrent包中提供了一个Callable接口和一组相关机制，能够帮助程序员安全、快速、简洁的完成以上的功能（线程执行完成后，返回一个执行结果）。Callable接口中需要实现的接口方法为call()，这个方法有一个泛化的返回值 V，可以帮助您返回定义的任何一种对象结果。接口源代码如下：</p>
<pre><code>public interface Callable&lt;V&gt; {
    /**
     * Computes a result, or throws an exception if unable to do so.
     *
     * @return computed result
     * @throws Exception if unable to compute a result
     */
    V call() throws Exception;
}</code></pre>
<p>下面我们通过一段简单的代码，看一下Callable接口是如何完成执行结果的返回和激活等待线程的：</p>
<pre><code>package test.thread.base.callfurther;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

/**
 * 测试可监控状态的线程
 * @author yinwenjie
 * @param &lt;V&gt;
 */
public class MyCallableThread&lt;V extends Entity&gt; implements Callable&lt;V&gt; {

    private V resultsEntity;

    public MyCallableThread(V param) {
        this.resultsEntity = param;
    }

    /* (non-Javadoc)
     * @see java.util.concurrent.Callable#call()
     */
    @Override
    public V call() throws Exception {
        try {
            // 等待一段时间，模拟业务执行过程
            synchronized (this) {
                this.wait(5000);
            }
            // 设置返回结果
            this.resultsEntity.setStatus(1);
        } catch(Exception e) {
            // 执行错误了，也设置
            this.resultsEntity.setStatus(-1);
        }

        return this.resultsEntity;
    }

    public static void main(String[] args) throws Exception {
        //这是您定义的一个模型对象。里面有一个status属性
        MyCallableThread&lt;Entity&gt; callableThread = new MyCallableThread&lt;Entity&gt;(new Entity());

        // Callable需要在线程池中执行
        ExecutorService es = Executors.newFixedThreadPool(1);
        Future&lt;Entity&gt; future = es.submit(callableThread);

        // main线程会在这里等待，知道callableThread任务执行完成
        Entity result = future.get();
        System.out.println("result.status = " + result.getStatus());
        // 停止线程池工作
        es.shutdown();
        es.awaitTermination(Long.MAX_VALUE, TimeUnit.DAYS);
    }
}</code></pre>
<p>从以上给出的使用代码，包括以下几个实际动作：</p>
<ul>
<li>Entity这个class，是为了记录线程执行的返回结果由我们自行定义的一个Class。实际上，对于MyCallableThread来说，只要继承了Entity的所有子类，都是可以作为它的泛化值的。</li>
<li><strong>目前Callable定义的线程任务，只能放入线程池中，由线程池中的任务进行执行</strong>。没有类似于Runnable接口那样，new Thread(new MyDefindRunnable())并且start()的线程运行方式。</li>
<li>Future用于描述当前任务线程的执行状态。您可以使用isDone、isCancelled等方法，来获取当前任务线程的执行状态。</li>
<li><strong>Future接口中的get方法，将会是当前线程进入阻塞状态。直到目标线程执行完毕，并且得到目标线程的返回结果</strong>。</li>
</ul>
<blockquote><p>Waits if necessary for the computation to complete, and then retrieves its result.</p>
<p><strong>Returns</strong>: the computed result</p>
<p><strong>Throws</strong>:</p>
<p>CancellationException - if the computation was cancelled</p>
<p>ExecutionException - if the computation threw an exception</p>
<p>InterruptedException - if the current thread was interrupted while waiting</p></blockquote>
<h1>3、JDK新特性锁：java.util.concurrent.locks包</h1>
<p>java.util.concurrent有一个locks子包，这个子包提供了一种JDK1.5版本中设计的一种新的锁机制。其中重要的包括两种类型的锁：ReentrantLock通用锁和ReentrantReadWriteLock读写锁。这个小结我们主要介绍这两种新得锁形态的使用。</p>
<h2>3-1、Lock-&gt;ReentrantLock通用锁</h2>
<p>在JDK1.5版本中，Doug Lea加入了两种新的对象锁方式，ReentrantLock和ReentrantReadWriteLock。在之前的版本中，如果我们要为某个线程中操作的对象加锁，写法如下：</p>
<pre><code>......
synchronized (ThreadLock.WAIT_OBJECT) {
    ThreadLock.LOGGER.info("做了一些事情。。。。");
}
......</code></pre>
<p>这个需要加锁的对象进行同步检查，同步边界内的代码只允许某一条线程A进入，除非线程A退出了同步边界或者通过wait等方法进入了阻塞状态，这段代码才允许其他线程访问。</p>
<p>在使用synchronized关键字的时候，您还需要特别关注interrupt异常。实际上这是因为JVM不允许停止“正在等待同步锁”的线程（这是更深入的知识点了）。</p>
<p>那么如果您使用ReentrantLock为多个线程在共享资源的线程块进行阻塞控制，就要比使用synchronized关键字简单许多（至少从表面现象来看是这样的），而且您不需要特别关注interrupt异常（至少从表面现象来看是这样的）。</p>
<p>还记得我们在《<a href="http://blog.csdn.net/yinwenjie/article/details/50403620" rel="external nofollow noreferrer">线程基础：线程（2）——JAVA中的基本线程操作（上）</a> 》这篇文章中，给出的一段在多线程情况下使用对象锁的最简单代码吗？没事，不用特意去翻这篇文章，这里我们再给出一次就行了（为了节约篇幅，只给重要的代码片段）：</p>
<pre><code>......
/**
 * 拿来加锁的对象
 */
private static final Object WAIT_OBJECT = new Object();
......

Thread threadA = new Thread(new Runnable() {
    @Override
    public void run() {
        // 检查‘对象锁‘状态。
        synchronized (ThreadLock.WAIT_OBJECT) {
            ThreadLock.LOGGER.info("做了一些事情。。。。");
        }
    }
});

Thread threadB = new Thread(new Runnable() {
    @Override
    public void run() {
        // 检查‘对象锁‘状态。
        synchronized (ThreadLock.WAIT_OBJECT) {
            ThreadLock.LOGGER.info("做了另一些事情。。。。");
        }
    }
});
threadA.start();
threadB.start();
......</code></pre>
<p>现在我们使用ReentrantLock方式，对之前这段代码进行更改：</p>
<pre><code>......
public void test() {
    final ReentrantLock objectLock = new ReentrantLock();

    new Thread() {
        public void run() {
            objectLock.lock();
            TestReentrantLock.LOG.info("做了一些事情。。。。");
            objectLock.unlock();
        }
    }.start();

    new Thread() {
        public void run() {
            objectLock.lock();
            TestReentrantLock.LOG.info("做了另一些事情。。。。");
            objectLock.unlock();
        }
    }.start();
}
......</code></pre>
<p>很显然，下面使用ReentrantLock方式改写后的代码是不是好理解多了。实际上最直观的理解就是将synchronized关键字的边界换成了 lock和unlock方法（但事实上并非如此）。至少线程您不需要关心interrupt异常了。</p>
<h2>3-2、ReadWriteLock-&gt;ReentrantReadWriteLock读写锁</h2>
<p>在java.util.concurrent.locks包中，还提供了一个ReentrantReadWriteLock工具。很显然，根据这个类的名字就明白了它的含义，即将多个线程对指定对象的读操作和写操作分开加锁。</p>
<p>我们可以使用以下代码，来获取对象的写锁</p>
<pre><code>WriteLock writeLock = objectLock.writeLock();</code></pre>
<p>使用以下代码，来获取对象的读锁：</p>
<pre><code>ReadLock readLock = objectLock.readLock();</code></pre>
<p>那么对象的写锁和读锁是怎么互相影响的呢？这个需要分开进行描述，首先我们来讨论一下，什么情况下线程可以获取某个对象的读锁：</p>
<ul>
<li>如果没有任何线程获取了对象的写锁。</li>
<li>虽然有线程获取了对象的写锁，但是这个线程就是当前请求读锁的线程</li>
</ul>
<p>那么<strong>当前是否有线程获取了对象的读锁，并不会影响当前线程继续获取对象的读锁</strong>。什么情况下线程可以获取某个对象的写锁：</p>
<ul>
<li>没有任何线程获取了这个对象的读锁</li>
<li>没有任何线程获取了这个对象的写锁</li>
</ul>
<p>注意，这里没有“虽然”的说法。也就是说，在同一个线程中的以下这种写法将会导致死锁：</p>
<pre><code>......
ReadLock readLock = objectLock.readLock();
readLock.lock();
WriteLock writeLock = objectLock.writeLock();
// 线程操作会被一直阻塞在这里
writeLock.lock();
......</code></pre>
<p>但是，同一个线程中的以下这种写法，就没有问题：</p>
<pre><code>......
WriteLock writeLock = objectLock.writeLock();
writeLock.lock();
ReadLock readLock = objectLock.readLock();
readLock.lock();
......</code></pre>
<p>以下是所有示例代码：</p>
<pre><code>package test.thread.reentrant;

import java.util.concurrent.locks.ReentrantReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock.ReadLock;
import java.util.concurrent.locks.ReentrantReadWriteLock.WriteLock;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.log4j.BasicConfigurator;

public class TestReadWriteReentrantLock {

    static {
        BasicConfigurator.configure();
    }

    /**
     * 日志
     */
    private static final Log LOG = LogFactory.getLog(TestReadWriteReentrantLock.class);

    public static void main(String[] args) throws RuntimeException {
        new TestReadWriteReentrantLock().test();
    }

    public void test() {
        final ReentrantReadWriteLock objectLock = new ReentrantReadWriteLock();

        Thread thread1 = new Thread() {
            public void run() {
                WriteLock writeLock = objectLock.writeLock();
                writeLock.lock();
                TestReadWriteReentrantLock.LOG.info("做了一些写操作的事情。。。。");
                writeLock.unlock();
            }
        };

        Thread thread2 = new Thread() {
            public void run() {
                WriteLock writeLock = objectLock.writeLock();
                writeLock.lock();
                TestReadWriteReentrantLock.LOG.info("做了另一些写操作的事情。。。。");
                writeLock.unlock();
            }
        };

        Thread thread3 = new Thread() {
            public void run() {
                ReadLock readLock = objectLock.readLock();
                readLock.lock();
                TestReadWriteReentrantLock.LOG.info("做了一些读操作的事情。。。。");
                readLock.unlock();
            }
        };

        //thread1、thread2、thread3在运行过程中，将按照我们之前描述的规律，相互作用
        thread1.start();
        thread2.start();
        // 您可以使用thread1.interrupt()指令对ReentrantLock的影像。
        // 您可以发现，thread1在加锁后并不会抛出interruptException异常
        // 至少在我们这种使用方式下，不会抛出异常
        // thread1.interrupt();
        thread3.start();
    }
}</code></pre>
<p>这里要重点说明一下，在大多数情况下您使用sycnchronized关键字或者使用ReentrantLock方式，都没有问题（这是因为90%的情况下，sycnchronized并不会真正的阻塞）。<strong>完全没有必要为了使用性能更好的ReentrantLock方式，而改变您历史代码版本中的sycnchronized关键字</strong>。</p>
<p>后续如果有时间，我将和大家讨论sycnchronized方式和ReentrantLock方式在工作原理上的不同。但是由于我在这个专栏上耗费了太多时间，所以只有暂缓。如果您想马上深入理解他们的工作原理，这里我推荐一篇文章：（<a href="http://www.ibm.com/developerworks/library/j-jtp10264/" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/library/j-jtp10264/</a>）</p>
<p>下文中，我们将以一个“赛跑”的例子，讲解JDK1.5环境下一些线程控制工具（包括Semaphore、CountDownLatch和java.util.concurrent.atomic子包）。并且复习这个专题讲到的知识点：同步快、锁、线程池、BlockingQueue、Callable等。当然还有线程间数据传递的方式。</p>
<p>（接下文）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 10:47:04 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>线程基础：JDK1.5+（8）——线程新特性（上）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jmeODM.html" rel="bookmark">Java基础：JDK1&period;5后的新特性：自动拆装箱，以及注意事项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先来看一段代码: 1 Integer x = new Integer(4); 2 Integer y = 4; 在JDK1.5版本后,以上两行代码都能编译通过,那是因为JDK1.5后加入新特性,自动装箱. 第一句代码是正常的创建对象方法,创建了一个Integer包装类对象. 而第二句中,当左边的Interger类型变量指向右边的int基本类型数据时,右边的基本数据类型会自动装箱成Integer对象,即隐式执行了new Integer(4). 再来一段代码: 1 Integer x = new			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M622WNM.html" rel="bookmark">jdk1&period;5出现的新特性----&amp;gt&semi;增强for循环</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package cn.itcast.jdk15; import java.util.HashMap;import java.util.HashSet;import java.util.Iterator;import java.util.Map;import java.util.Set; /*jdk1.5出现的新特性----&gt;增强for循环 增强for循环的作用: 简化迭代器的书写格式.(注意:增强for循环的底层还是使用了迭代器遍历.) 增强for循环的适用范围: 如果是实现了Iterable接			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y9JKw0.html" rel="bookmark">前端面试基础-html篇之H5新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				h5的新特性(目前个人所了解)如下 语义化标签 表单新特性 视频(video)和音频(audio) canvas画布 svg绘图 地理定位 为鼠标提供的拖放API webworker (重点)Storage (重点)Websocket HTML语义化是什么? 语义化是指根据内容的结构化(内容语义化),选择合适的标签(代码语义化),便于开发者阅读和写出更优雅的代码的同时,让浏览器的爬虫和机器很好的解析. 为什么要语义化? 有利于SEO,有助于爬虫抓取更多的有效信息,爬虫是依赖于标签来确定上下文和各			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Zpgy8M.html" rel="bookmark">C&num; 2&period;0 新特性&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C# 2.0新特性 1. 泛型 1.1 泛型介绍 泛型类和泛型方法同时具备可重用性.类型安全和效率,这是非泛型类和非泛型方法无法具备的.泛型通常用在集合和在集合上运行的方法中..NET Framework 2.0 版类库提供一个新的命名空间 System.Collections.Generic,其中包含几个新的基于泛型的集合类.建议面向 2.0 版的所有应用程序都使用新的泛型集合类,而不要使用旧的非泛型集合类,如 ArrayList.有关更多信息,请参见 .NET Framework 类库中的泛			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JpBzl0.html" rel="bookmark">Java基础之JDK1&period;8的接口新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java的JDK1.8中: 1.接口中使用default来修饰普通方法与使用static来修饰普通方法的意义用于避免子类重复实现同样的代码 1 package test; 2 /** 3 * 泛型的使用 4 * @author Administrator 5 * 6 */ 7 public class TestType { 8 9 public static void main(String[] args) { 10 Msg msg = new MsgImpl(); 11 msg.show()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xnWxD4.html" rel="bookmark">JDK1&period;7的一些新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				整理了几条对开发可能用到概率高的 1.swicth支持对String的判断:(以前只能支持Int及以下的) switch (s) { case &quot;1&quot;: break; case &quot;2&quot;: break; case &quot;3&quot;: break; } 2.泛型的改善 //JDK1.7 Map&lt;String,String&gt; map = new HashMap&lt;&gt;(); //JDK1.6 Map&lt;String,String&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzYjDk4.html" rel="bookmark">java基础1&period;5版后新特性 自动装箱拆箱 Date SimpleDateFormat Calendar&period;getInstance&lpar;&rpar;获得一个日历对象 抽象不要生成对象 get set add System&period;arrayCopy&lpar;&rpar;用于集合等的扩容</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8种基本数据类型的8种包装类 byte Byte short Short int Integer long Long float Float double Double char Character boolean Boolean Integer a=127; Integer b=127;//虚拟机自动装箱时进行了特殊处理,-127~128以下的自动取有过的 System.out.println(a==b);结果为true 如果是Integer a=128; Integer b=128; Sys			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLOAK0.html" rel="bookmark">java新特性上</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jdk5.0以及5.0之后的版本: 静态导入 自动装箱和拆箱 增强for循环 可变参数 枚举类型 泛型 反射 内省 元数据 静态导入 package java静态导入; import static java.lang.System.out; //用的不多,可阅读性下降 import org.junit.Test; public class Demo { @Test public void test(){ out.print(&quot;静态导入测试&quot;); } } 可变参数 package 可变参			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmOV6Q3.html" rel="bookmark">第6章 线程基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.1 线程基础 (1)线程组成:线程内核对象+线程栈(注意:进程=进程内核对象+地址空间) ①从内核角度看,线程是一个内核对象,系统用它来存储一些关于线程的统计信息(比如运行时间等) ②从编程角度看,线程是一堆寄存器状态以及线程栈的一个结构体对象.本质上可以理解为一个函数的调用器(其中的寄存器状态用于控制CPU执行,栈用于存储局部变量和函数参数及函数的返回地址)——为什么要使用线程栈的? 线程1 线程2 备注(使用线程栈的原因分析) void func1(){ int a; int b; }			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/D3OQE9M.html" rel="bookmark">Extjs5&period;0从入门到实战开发信息管理系统（Extjs基础、Extjs5新特性、Spring、Spring mvc、Mybatis）视频教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Extjs5.0从入门到实战开发信息管理系统(Extjs基础.Extjs5新特性.Spring.Spring mvc.Mybatis)视频教程下载   联系QQ:1026270010 Extjs作为一款优秀的JS前端开发框架以其良好的架构.丰富的UI组件库.完善的文档和社区支持等诸多优点拥有广泛的市场应用空间,开发人员无需过多的关注HTML.CSS甚至各种常用JS算法,只需把精力放在业务逻辑上,利用各种组件的相互组合调用便可轻松而高效的开发出系统的前端页面. Extjs5在之前版本的基础上又推出			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35KeXM.html" rel="bookmark" class="title">开始的日子。</a>
					<div>
						回顾HTML,跑马灯--&lt;marquee&gt;跑马灯内容&lt;/marquee&gt; 参数:                                                 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdd28M.html" rel="bookmark" class="title">Javascript操作DOM常用API总结</a>
					<div>
						Javascript操作DOM常用API总结 原文地址:http://luopq.com/2015/11/30/javascript-dom/ 类型 Node类型(ELEMENT_NODE:1 ATT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47N7JD3.html" rel="bookmark" class="title">best-time-to-buy-and-sell-stock I &amp;amp&semi;&amp;amp&semi;II &amp;amp&semi;&amp;amp&semi; III &amp;amp&semi;&amp;amp&semi; IVbest-time-to-buy-and-sell-stock-ii</a>
					<div>
						1.买卖股票的最佳时机 假设有一个数组,它的第i个元素是一支给定的股票在第i天的价格.如果你最多只允许完成一次交易(例如,一次买卖股票),设计一个算法来找出最大利润. 1 public class S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEXLX0.html" rel="bookmark" class="title">iOS使用TFHpple解析html</a>
					<div>
						iOS 开发中解析html 网上有很多写好的解析框架 今天就来讲一下如何用框架TFHpple来解析html 使用TFHpple解析html github地址:https://github.com/to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGOe8M.html" rel="bookmark" class="title">Objective-C基础笔记（7&rpar;Foundation中的经常使用结构体</a>
					<div>
						一.NSRange NSRange的定义: typedef struct _NSRange { NSUInteger location; NSUInteger length; } NSRange; N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e77lZ4.html" rel="bookmark" class="title">阿里大鱼短信接口 for Thinkphp</a>
					<div>
						不得不说阿里云为创业者在起步时期提供了不少便利,短信接口不管是web应用还是APP都必不可少.大鱼一张口,这是要生吞其他小虾米的节奏啊,四分的价格很便宜了,现在注册会送60元代金券,时间不到一个月,也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpljE3.html" rel="bookmark" class="title">指南针开发</a>
					<div>
						ios 定位新功能----在程序中实现定位功能 转:http://www.2cto.com/kf/201501/369336.html 2015-01-14      0个评论    来源:haoga ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xv61D4.html" rel="bookmark" class="title">TF-IDF模型的概率解释</a>
					<div>
						信息检索概述 信息检索是当前应用十分广泛的一种技术,论文检索.搜索引擎都属于信息检索的范畴.通常,人们把信息检索问题抽象为:在文档集合D上,对于由关键词w[1] … w[k]组成的查询串q,返回一个按 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPGQK4.html" rel="bookmark" class="title">换Linux了</a>
					<div>
						...一把辛酸泪 码一下对拍程序: 1 while true; do 2 ./3&gt;4810.in #出数据 3 ./1&lt;4810.in&gt;cuo.out #被测程序 4 ./2&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nL5AK4.html" rel="bookmark" class="title">NS3网络仿真（3）： NetAnim</a>
					<div>
						快乐虾 http://blog.csdn.net/lights_joy/ 欢迎转载,但请保留作者信息 在NS3提供的示例first.py中,并没有生成NetAnim所需要的xml文件,本节我们尝试用N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvRKa3.html" rel="bookmark" class="title">使用FileResult导出txtl数据文件</a>
					<div>
						public FileResult ExportMobileNoTxt(SearchClientModel model){ var sbTxt = new StringBuilder(); for ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqKdb0.html" rel="bookmark" class="title">11&period;Set 和 Map数据结构</a>
					<div>
						1.set 基本用法 ES6 提供了新的数据结构 Set.它类似于数组,但是成员的值都是唯一的,没有重复的值. Set 本身是一个构造函数,用来生成 Set 数据结构. const s = new S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWKPa0.html" rel="bookmark" class="title">java中的位运算及移位运算</a>
					<div>
						为了方便对二进制位进行操作,Java给我们提供了以下四个二进制位操作符: &amp;    按位与 |     按位或 ^    按位异或 ~    按位取反 Java中有三个移位运算符: 左移:&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBzwQ0.html" rel="bookmark" class="title">Java RandomAccessFile用法（转）</a>
					<div>
						原文链接:http://blog.csdn.net/akon_vm/article/details/7429245 RandomAccessFile RandomAccessFile是用来访问那些保存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlkvaM.html" rel="bookmark" class="title">scrollHeight&comma;scrollLeft&comma;offsetHeight&comma;offsetLeft</a>
					<div>
						scrollHeight: 获取对象的滚动高度. scrollWidth:获取对象的滚动宽度 scrollLeft:设置或获取位于对象左边界和窗口中目前可见内容的最左端之间的距离scrollTop:设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l112Z3.html" rel="bookmark" class="title">两个链表第一个公共点</a>
					<div>
						题目描述 输入两个链表,找出它们的第一个公共结点. 思路:用两个指针扫描&quot;两个链表&quot;,最终两个指针到达 null 或者到达公共结点. 代码所基于的想法是,将两个链表L1和L2进行拼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPJ1bM.html" rel="bookmark" class="title">魔术师发牌问题和拉丁方阵问题</a>
					<div>
						魔术师发牌问题 问题描述: 魔术师利用一副牌中的13张黑牌,预先将他们排好后叠放在一起,牌面朝下.对观众说:“我不看牌,只数数就可以猜到每张牌是什么,我大声数数,你们听,不信?现场演示.”魔术师将最上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Xzjz4.html" rel="bookmark" class="title">caffe学习笔记（1）安装 - Ubuntu 15&period;04</a>
					<div>
						官方安装手册 备注:使用系统 - Ubuntu 15.04 64位操作系统(若系统位于虚拟机上,在安装CUDA后,Ubuntu将无法进入图形界面) /************************* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPRoO3.html" rel="bookmark" class="title">python 全栈  python基础 （七）文件操作 笔记（随时更改添加）</a>
					<div>
						文件操作流程: 1.打开文件 open() 2.操作文件 read .writeread(n) n对应读指定个数的 2.x中读取的是字节! 3.x中读取的是字符!read 往外读取文件,是以光标位置开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ea11w0.html" rel="bookmark" class="title">ps -ef&sol;ps -aux 查看正在活动的进程</a>
					<div>
						ps -ef 查看正在活动的进程 ps -ef |grep abc 查看含有&quot;abc&quot;的活动进程 ps -ef |grep -v abc 查看不含abc的活动进程 1)ps a 显 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
